<?php
/**
* Simple isotope module  - Joomla Module 
* Version			: 1.0.22
* Package			: Joomla 3.x.x
* copyright 		: Copyright (C) 2016 ConseilGouz. All rights reserved.
* license    		: http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* From              : isotope.metafizzy.co
* Updated on        : October, 2016
* 01.0.20           : weblinks: calcul link incorrect
*/
defined('_JEXEC') or die;
/**
 * Helper for mod_isotope
 */

class ModIsotopeHelper
{


	public static function getWebLinks(&$params) {
			$options = array();
			$options['countItems'] = $params->get('show_cat_num_links', 1) || !$params->get('show_empty_categories_cat', 0);
			$categories = JCategories::getInstance('Weblinks', $options);
			if (!$categories) {
				JFactory::getApplication()->enqueueMessage(JText::_('Module Simple Isotope : pas de cat&eacute;gorie liens web'), 'notice');
				return false; // pas de cat�gorie: on sort
			}
			$parent = $categories->get('root');
			$parent->_items = $parent->getChildren();	
			if (!$parent->_items) {
				JFactory::getApplication()->enqueueMessage(JText::_('Module Simple Isotope : Pas de lien web'), 'notice');
				return false; // pas de weblinks : on sort
			}
			foreach ($parent->_items as  $categorie)
			{	
				$result[$categorie->id] = self::getWebLinksCategorie($categorie->id,$categorie->alias);
			}
			return $result;
	}

	public static function getWebLinksCategorie($id,$alias)
	{
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('*')
			->from('#__weblinks AS u')
			->where('catid = '.$id.' AND state = 1')
			;
		$db->setQuery($query);
		$items= $db->loadObjectList();
		if ($items)
		{
			foreach ($items as $item)
			{ // 01.0.20 : calcul link pour prendre en compte les clicks (visites)
					$item->link	= JRoute::_('index.php?option=com_weblinks&task=weblink.go&catid=' . $id . ':'.$alias.'&id=' . $item->id.':'.$item->alias);
			
			}
			return $items;
		}
		return false;
	}	
    public static function gebWebLinksCategoryName($id) 
	{
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);

		// Construct the query
		$query->select('title')
			->from('#__categories ')
			->where('id = '.$id)
			;
		// Setup the query
		$db->setQuery($query);
		return $db->loadResult();
		
	}
	static function getCategory($id,$params,&$tags,&$article_tags,$module) {

		// Get an instance of the generic articles model
		$articles = JModelLegacy::getInstance('Articles', 'ContentModel', array('ignore_request' => true));
		if ($articles) {
		// Set application parameters in model
		$app       = JFactory::getApplication();
		$appParams = $app->getParams();
		$articles->setState('params', $appParams);

		// Set the filters based on the module params
		$articles->setState('list.start', 0);
		$articles->setState('list.limit', (int) $params->get('count', 0));
		$articles->setState('filter.published', 1);

		// Access filter
		$access     = !JComponentHelper::getParams('com_content')->get('show_noauth');
		$authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
		$articles->setState('filter.access', $access);
		$catids = $id;
		$articles->setState('filter.category_id', $catids);		
		$articles->setState('filter.category_id.include', (bool) $params->get('category_filtering_type', 1));
		// Ordering
		$ordering = $params->get('article_ordering', 'a.ordering');
		$articles->setState('filter.featured', $params->get('show_front', 'show'));
		$articles->setState('filter.author_id', $params->get('created_by', ""));
		$articles->setState('filter.author_id.include', $params->get('author_filtering_type', 1));
		$articles->setState('filter.author_alias', $params->get('created_by_alias', ""));
		$articles->setState('filter.author_alias.include', $params->get('author_alias_filtering_type', 1));
		$excluded_articles = $params->get('excluded_articles', '');

		if ($excluded_articles)
		{
			$excluded_articles = explode("\r\n", $excluded_articles);
			$articles->setState('filter.article_id', $excluded_articles);

			// Exclude
			$articles->setState('filter.article_id.include', false);
		}
		$date_filtering = $params->get('date_filtering', 'off');
		// Filter by language
		$articles->setState('filter.language', $app->getLanguageFilter());
		$items = $articles->getItems();
		
				// Display options
		$introtext_limit  = $params->get('introtext_limit', 100);
		$show_date_field  = $params->get('choixdate', 'modified');
		$show_dspcomp	  = $params->get('dspcomp','yes');       			//display complet article yes or no (default no)
		$show_date        = true;
		$show_introtext   = true;
		$show_category    =  0;
		$show_hits        =  0;
		$show_author      =  0;
		$show_date_format = 'Y-m-d H:i:s';

		foreach ($items as &$item)
		{
			$item->slug    = $item->id . ':' . $item->alias;
			$item->catslug = $item->catid . ':' . $item->category_alias;

			if ($access || in_array($item->access, $authorised))
			{
				// We know that user has the privilege to view the article
				$item->link = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catid, $item->language));
			}
			else
			{
				$menu      = $app->getMenu();
				$menuitems = $menu->getItems('link', 'index.php?option=com_users&view=login');
				if (isset($menuitems[0]))
				{
					$Itemid = $menuitems[0]->id;
				}
				elseif ($app->input->getInt('Itemid') > 0)
				{
					$Itemid = $app->input->getInt('Itemid');
				}

				$item->link = JRoute::_('index.php?option=com_users&view=login&Itemid=' . $Itemid);
			}
			$item->displayDate = '';
			if ($show_date)
			{
				$item->displayDate = JHtml::_('date', $item->$show_date_field, $show_date_format);
			}
			if ($item->catid)
			{
				$item->displayCategoryLink  = JRoute::_(ContentHelperRoute::getCategoryRoute($item->catid));
				$item->displayCategoryTitle = $show_category ? '<a href="' . $item->displayCategoryLink . '">' . $item->category_title . '</a>' : '';
			}
			else
			{
				$item->displayCategoryTitle = $show_category ? $item->category_title : '';
			}

			$item->displayHits       = $show_hits ? $item->hits : '';
			$item->displayAuthorName = $show_author ? $item->author : '';
			if ($show_introtext)
			{
				if (!strpos($item->introtext,'{loadposition '.$module->position.'}')) { // ne pas prendre ce module, sinon on boucle
					$item->introtext = JHtml::_('content.prepare', $item->introtext, '', 'mod_articles_category.content');
				}
				$item->introtext = self::cleanIntrotext($item->introtext,$show_dspcomp);
			}
			$item->displayIntrotext = $show_introtext ? self::truncate($item->introtext, $introtext_limit) : '';
			$item->displayReadmore  = $item->alternative_readmore;
			$article_tags[$item->id] = self::getArticleTags($item->id); // r�cup�ration des tags de l'article
			foreach ($article_tags[$item->id] as $tag) { 
				if (!in_array($tag->tag, $tags)) $tags[]=$tag->tag;
			}
		}
		return $items;
		}
		else { return false;
		}

	}
	public static function getTagTitle($id) {
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		// Construct the query
		$query->select('tags.title as tag')
			->from('#__tags as tags')
			->where('tags.id = '.$id)
			;
		$db->setQuery($query);
		return $db->loadResult();
	}
	public static function getArticleTags($id) {
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('tags.title as tag')
			->from('#__contentitem_tag_map as map ')
			->innerJoin('#__content as c on c.id = map.content_item_id') 
			->innerJoin('#__tags as tags on tags.id = map.tag_id')
			->where('c.id = '.$id)
			;
		$db->setQuery($query);
		return $db->loadObjectList();
	}
	
	public static function cleanIntrotext($introtext,$dspcomp)
	{
		
		if ($dspcomp == 'no'){											//display complet article yes or no
		$introtext = str_replace('<p>', ' ', $introtext);
		$introtext = str_replace('</p>', ' ', $introtext);
		$introtext = strip_tags($introtext, '<a><em><strong>');
		$introtext = trim($introtext);
        }
		return $introtext;
        
	}

	public static function truncate($html, $maxLength = 0)
	{
		$baseLength = strlen($html);
		$ptString = JHtml::_('string.truncate', $html, $maxLength, $noSplit = true, $allowHtml = false);
		for ($maxLength; $maxLength < $baseLength;)
		{
			$htmlString = JHtml::_('string.truncate', $html, $maxLength, $noSplit = true, $allowHtml = true);
			$htmlStringToPtString = JHtml::_('string.truncate', $htmlString, $maxLength, $noSplit = true, $allowHtml = false);
			if ($ptString == $htmlStringToPtString)
			{
				return $htmlString;
			}
			$diffLength = strlen($ptString) - strlen($htmlStringToPtString);
			$maxLength += $diffLength;
			if ($baseLength <= $maxLength || $diffLength <= 0)
			{
				return $htmlString;
			}
		}
		return $html;
	}
}
